// EODefines.h
// Copyright (c) 1996, NeXT Software, Inc. All rights reserved. 
//
//
//  Platform specific defs for externs
//

#ifndef _EOCONTROLDEFINES_H
#define _EOCONTROLDEFINES_H

//
// For MACH
//

#if defined(__MACH__)

#ifdef __cplusplus
   // This isnt extern "C" because the compiler will not allow this if it has
   // seen an extern "Objective-C"
#  define EOCONTROL_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#else
#  define EOCONTROL_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#endif

#define EOCONTROL_EXTERN_IMP	PUBLIC_EXTERN
#define PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


//
// For Windows
//

#elif defined(WIN32)

#ifdef __cplusplus
#  ifndef _NSBUILDING_EOCONTROL_DLL
#    define EOCONTROL_EXTERN		__declspec(dllimport) extern "C"
#  else
#    define EOCONTROL_EXTERN		extern "C"
#  endif
#  define EOCONTROL_PRIVATE_EXTERN		extern "C"
#else
#  ifndef _NSBUILDING_EOCONTROL_DLL
#    define EOCONTROL_EXTERN		__declspec(dllimport) extern
#  else
#    define EOCONTROL_EXTERN		extern
#  endif
#    define EOCONTROL_PRIVATE_EXTERN		extern
#endif

#define EOCONTROL_EXTERN_IMP	PUBLIC_EXTERN
#define EOCONTROL_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


//
//  For Solaris and SolarisOpenStep
//

#elif defined(__svr4__) || defined(sun)

#ifdef __cplusplus
#  define EOCONTROL_EXTERN		extern "C"
#  define EOCONTROL_PRIVATE_EXTERN		extern "C"
#else
#  define EOCONTROL_EXTERN		extern
#  define EOCONTROL_PRIVATE_EXTERN		extern
#endif

#define EOCONTROL_EXTERN_IMP	EOCONTROL_EXTERN
#define EOCONTROL_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

#elif defined(hpux)

#ifdef __cplusplus
#  define EOCONTROL_EXTERN		extern "C"
#  define EOCONTROL_PRIVATE_EXTERN		extern "C"
#else
#  define EOCONTROL_EXTERN		extern
#  define EOCONTROL_PRIVATE_EXTERN		extern
#endif

#define EOCONTROL_EXTERN_IMP	EOCONTROL_EXTERN
#define EOCONTROL_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

#elif defined(SolarisOpenStep)

#ifdef __cplusplus
#  define EOCONTROL_EXTERN		extern "C"
#  define EOCONTROL_PRIVATE_EXTERN		extern "C"
#else
#  define EOCONTROL_EXTERN		extern
#  define EOCONTROL_PRIVATE_EXTERN		extern
#endif

#define EOCONTROL_EXTERN_IMP	EOCONTROL_EXTERN
#define EOCONTROL_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

#else

#error Unknown platform.

#endif

#endif // _EOCONTROLDEFINES_H

