// EOGenericRecord.h
// Copyright (c) 1994, NeXT Software, Inc. All rights reserved.

#import <EOControl/EOControl.h>

// EOGenericRecords are associated with EOEntities for which you haven't
// defined custom Enterprise Object classes.  When a record from the entity's
// table is fetched by an database-layer object, an EOGenericRecord is
// instantiated and filled with the data from the row.  Any other enterprise
// object class is uniquely associated with an EOEntity object in a given
// EOModel.  Since EOGenericRecords need to be used for any entity, an
// EOGenericRecord holds the entity with which it's associated.

@interface EOGenericRecord:NSObject
{
    EOClassDescription *classDescription;
    NSMutableDictionary *dictionary;
}

- initWithEditingContext:(EOEditingContext *)ec
    classDescription:(EOClassDescription *)classDesc
    globalID:(EOGlobalID *)globalID;
    // Initializes a newly allocated EOGenericRecord, associating it with
    // entity.

- (id)valueForKey:(NSString *)key;
- (void)takeValue:(id)value forKey:(NSString *)key;
    // These are the standard methods for getting data into and out of
    // Enterprise Objects.  See EOKeyValueCoding.h.
@end

