// EONull.h
// Copyright (c) 1994, NeXT Software, Inc.  All rights reserved.
//
// The EONull object is used to represent nil in collection classes (in particular,
// NSDictionaries).  Enterprise Objects should never contain EONull (NULL values
// fetched from the database are automatically converted to nil when passed to
// your Enterprise Objects).
//
// You can check whether any value is null by comparing with the EONull instance.
//
//     if (myValue == [EONull null]) ...
//
#import <Foundation/Foundation.h>


@interface EONull:NSObject <NSCopying, NSCoding>

+ (EONull *)null;
    // Returns a unique instance representing null values in the database
    // server.

@end
