// EMProxyDataSource.h
// A dataSource that passes all calls off to it delegate
// Currently PRIVATE but may become public eventually

#import <EOControl/EODataSource.h>

@interface EOProxyDataSource : EODataSource
{
    id _delegate;
    SEL _fetchSelector;
    SEL _createSelector;
    SEL _insertSelector;
    SEL _deleteSelector;
    SEL _editContextSelector;
}

- (id)initWithDelegate:(id)delegate;

//------------------------------------------------------------------------
//  set/query
//------------------------------------------------------------------------

- (void)setDelegate:(id)delegate;
- (id)delegate;

- (SEL)fetchSelector;
- (void)setFetchSelector:(SEL)aSelector;
    // default is fetchObjects

- (SEL)createSelector;
- (void)setCreateSelector:(SEL)aSelector;
    // default is createObject:

- (SEL)insertSelector;
- (void)setInsertSelector:(SEL)aSelector;
    // default is insertObject:

- (SEL)deleteSelector;
- (void)setDeleteSelector:(SEL)aSelector;
    // default is deleteObject:

- (SEL)editingContextSelector;
- (void)setEditingContextSelector:(SEL)aSelector;
    // default is editingContext
@end
