#import <objc/maptable.h>
#import <Foundation/Foundation.h>
#import <EOControl/_EOInternallyRefCountedObject.h>

@class _EOMKKDSubsetMapping;
@class _EOMKKDArrayMapping;

@interface _EOMKKDInitializer : _EOInternallyRefCountedObject
{
    NSMapTable *uniqueKeyToIndexTable;
    NSMapTable *keyToIndexTable;
    unsigned int count;
    NSString *keys[1];  // actually more... we inline the keys.
                        // THIS MUST BE THE LAST STRUCTURE MEMBER
}
+ newWithKeyArray: (NSArray *)keyArray zone: (NSZone *)zone;
+ newWithKeyArray: (NSArray *)keys;
- (NSString **)keys;
- (unsigned)count;
- (_EOMKKDSubsetMapping *)subsetMappingForSourceDictionaryInitializer:(_EOMKKDInitializer *)source;
    // return a mapping object that can create instances of the receiver by grabbing keys
    // from the instances of the source, copying all keys in common.
- (_EOMKKDSubsetMapping *)subsetMappingForSourceDictionaryInitializer:(_EOMKKDInitializer *)other
    sourceKeys:(NSArray *)sourceKeys destinationKeys:(NSArray *)destinationKeys;
    // return a mapping object that can create instances of the receiver by setting
    // values for the given destination keys from the corresponding source keys.
- (_EOMKKDArrayMapping *)arrayMappingForKeys:(NSArray *)keys;
@end


@interface _EOMutableKnownKeyDictionary : NSMutableDictionary
{
    id info;
    NSMutableDictionary *extras;
    id values[1];			// The values held by the dictionary
    					// are allocated after the end of the
					// object.  If you add ivars
					// (and you're sure we need them!) add
					// them before values.  
}

+ initializerFromKeyArray: (NSArray *)keys;
    // FIX ME: with this name, this should return something autoreleased
    // Equivalent to [_EOMKKDInitializer newWithKeyArray:keys]

+ newWithInitializer: initializer zone:(NSZone *)zone;
+ newWithInitializer: initializer;
+ newWithInitializer:initializer objects:(id *)objects zone:(NSZone *)zone;
    // Objects array must contain exactly the number of objects as the
    // initializer has keys and be in the same order.
+ newDictionaryFromDictionary:(NSDictionary *)source subsetMapping:(_EOMKKDSubsetMapping *)mapping zone:(NSZone *)zone;
+ newDictionaryWithObjects:(id *)array arrayMapping:(_EOMKKDArrayMapping *)mapping
                      zone:(NSZone *)zone;
    // number and order of objects must match mapping object
@end

