/*
 * Copyright (c) 1996, NeXT Software, Inc.
 * All Rights Reserved.
 */

#import <Foundation/Foundation.h>
#import <ObjCJava/java-objc.h>

@interface NSJavaObject : NSObject <NSCoding>
{
    JAVAHandle javaHandle;
}

+ (id) objectWithJavaHandle:(JAVAHandle)javaHandle;
+ (id) newWithSignature:(NSString *)signature arguments:(va_list)args;
+ (id) newWithSignature:(NSString *)signature, ...;

- (id) initWithJavaHandle:(JAVAHandle)handle;

- (JAVAClass) javaClass;
- (JAVAHandle) javaHandle;

/*
 * Key/Value coding support.
 */
- (id) valueForKey:(NSString *)key;
- (void) takeValue:(id)value forKey:(NSString *)key;

@end
