/*
 * JavaBridge -- ObjCJava.h
 *
 * Copyright (C) 1997 Apple Computer, Inc.
 * All Rights Reserved.
 *
 */

#import <Foundation/Foundation.h>
#import <ObjCJava/NSJavaObject.h>
#import <ObjCJava/java-vm.h>


@interface NSProcessInfo (NextJavaHacks)
- (void) setArguments:(NSArray *)arguments;
@end

@interface NSCoder (JavaExtensions)

typedef long long longLong;

- (void)encodeDouble:(double)value;
- (void)encodeFloat:(float)value;
- (void)encodeLong:(longLong)value;
- (void)encodeInt:(int)value;
- (void)encodeShort:(short)value;
- (void)encodeByte:(char)value;
- (void)encodeChar:(unichar)value;
//- (void)encodeObject:(id)value;
- (double)decodeDouble;
- (float)decodeFloat;
- (longLong)decodeLong;
- (int)decodeInt;
- (short)decodeShort;
- (char)decodeByte;
- (unichar)decodeChar;
//- (id)decodeObject;
@end

@interface NSArchiver (JavaExtensions)
+ (id)unarchiveObjectWithFile:(NSString *)path;
@end

@interface NSMutableArray (NSJavaExtensions)
- (void)addElement:(id)elem;
@end

@interface NSCalendarDate (JavaHelper)
- initWithTimeIntervalSinceReferenceDate:(NSTimeInterval)ti;
@end
